/*
 *  gmc4asm.h
 *  gmc4asm
 *
 *  Created by Koyama Yoshiaki on 09/08/31.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <stdio.h>
#include <ctype.h>	
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <xlocale.h>

#define	TRUE		-1
#define FALSE		0
#define Boolean		int

#define STORAGE_MAX	0x60

extern int line_number;

typedef enum {
	TYPE_NULL,
	TYPE_OPCODE1,
	TYPE_OPCODE2,
	TYPE_CALL,
	TYPE_JUMP,
	TYPE_LABEL,
	TYPE_NIBBLE_DN,
	TYPE_ALIGN
} TypeOpcode;


struct Opcode1_tag {
	unsigned int code1;
	char *name;
};

struct Opcode2_tag {
	unsigned int code1;
	unsigned int code2;
	char *name;
};

struct Opcode_jump_tag {
	unsigned int code1;
	unsigned int code2;
	unsigned int code3;
	char *name;
};


struct Opcode_call_tag {
	unsigned int code1;
	unsigned int code2;
	char *name;
};


struct Opcode_label_tag {
	unsigned int adress;
	char *name;
};

struct Opcode_nibble_tag {
	unsigned int data;
	struct Opcode_nibble_tag *next;
};

struct Opcode_nibble_dn_tag {
	unsigned int adress;
	unsigned int data;
	struct Opcode_nibble_tag *next;
};

struct Opcode_align_tag {
	unsigned int adress;
};

struct Label_tag {
	Boolean flag;
	char *name;
	unsigned int adress;
};

typedef struct Opcode1_tag Opcode1;
typedef struct Opcode2_tag Opcode2;
typedef struct Opcode_jump_tag Opcode_jump;
typedef struct Opcode_call_tag Opcode_call;
typedef struct Opcode_label_tag Opcode_label;
typedef struct Opcode_nibble_dn_tag Opcode_nibble_dn;
typedef struct Opcode_nibble_tag Opcode_nibble;
typedef struct Opcode_align_tag Opcode_align;

typedef struct Label_tag Label;


/*
	Nibble = 4 bits
*/
struct Opcode_tag {
	int line_number;
	TypeOpcode type;
	Label label;
	int nibble_count;
	union {
		Opcode1 opcode1;
		Opcode2 opcode2;
		Opcode_jump opcode_jump;
		Opcode_call opcode_call;
		Opcode_label opcode_label;
		Opcode_nibble_dn opcode_nibble_dn;
		Opcode_align opcode_align;
	} u;
	struct Opcode_tag *next;
};

typedef struct Opcode_tag Opcode;

extern Opcode *Top;

/*
 
 */

struct Symrec_tag {
	char *name;
	unsigned int code;
	struct Symrec_tag *next;
};

typedef struct Symrec_tag Symrec;

extern Symrec *Table;

/*
 
 */

extern char *error_msg[];

/*
		function
 */

void add_top(Opcode *opcode);

char *name_malloc(char *name);
void name_free(char *name);
void strlower(char *name);
char *name_label_malloc(char *name);
	
	
Opcode *opcode_malloc();
void opcode_free(Opcode *opcode);
void init_opcode(Opcode *ptr, TypeOpcode type, char *name);

Boolean calc_label();
Boolean set_label();
Boolean set_align();
Boolean align_over(Opcode *ptr, unsigned int adress);

void print_top();
void print_space(int num);


void init_table();
Boolean putsym(char *name, unsigned int code);
unsigned int getsym(char *name);
void print_table();
Boolean set_table(char *name, unsigned int code);

unsigned int calc_dump(unsigned int *dump);
void print_dump(unsigned int *dump, unsigned int count);
void print_fxp(FILE *fp, unsigned int *dump, unsigned int count);
void print_hex(FILE *fp, unsigned int *dump, unsigned int count);

Opcode *chain_nibble_list(Opcode *opcode, unsigned int nibble);

void print_dump_data();
